package com.mjitech.qa.test;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.CookieStore;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import com.mjitech.qa.service.BaseService;
import com.mjitech.qa.util.DBConnection;

import net.sf.json.JSONObject;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

import org.testng.annotations.Test;

public class PickUpGoodsTest {
	BaseService service = new BaseService();
	JSONObject json = JSONObject.fromObject("{}");
	List<org.apache.http.cookie.Cookie> cookies = null;
	String cookiesValues = "";
	Map map = new HashMap();

	/**
	 * 批量获取SKU
	 */
	public List getSkuList(int warehouse_id) {
		List skuList = new ArrayList();
		DBConnection db = new DBConnection("test");
		ResultSet rs = null;
		
//		String sql = "SELECT sku_id FROM mt_inventory WHERE warehouse_id = " + warehouse_id
//				+ " AND quantity >0 AND STATUS = 1; ";
		String sql = "SELECT p.`id` AS 'pass_id' FROM mt_inventory t, mt_new_sku_pass p WHERE t.`warehouse_id` = p.`warehouse_id` AND t.`sku_id` = p.`sku_id` AND t.warehouse_id ="+warehouse_id+" AND t.quantity >0 AND t.STATUS = 1;";
		try {
			Statement stmt = db.conn.createStatement();
			rs = stmt.executeQuery(sql);
			while (rs.next()) {
				String pass_id = rs.getString("pass_id");
				skuList.add(pass_id);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return skuList;
	}

	/**
	 * 登录
	 */
	@Test
	public void login() {
		CookieStore cookieStore = new BasicCookieStore();
		String loginUrl = "https://test.mjitech.com/web/login.action";
		CloseableHttpClient client = HttpClients.custom().setDefaultCookieStore(cookieStore).build();
		HttpPost httpPost = new HttpPost(loginUrl);
		JSONObject jsonParam = new JSONObject();
		jsonParam.put("username", "gangwang@mjitech.com");
		jsonParam.put("password", "yier34wu6");
		StringEntity entity = new StringEntity(jsonParam.toString(), "utf-8");
		entity.setContentEncoding("UTF-8");
		entity.setContentType("application/json");

		try {
			httpPost.setEntity(entity);
			HttpResponse httpResponse = client.execute(httpPost);
			String responseString = EntityUtils.toString(httpResponse.getEntity());
			if (httpResponse.getStatusLine().getStatusCode() == 200) {
				List<org.apache.http.cookie.Cookie> cookies = cookieStore.getCookies();
				if (CollectionUtils.isNotEmpty(cookies)) {
					for (org.apache.http.cookie.Cookie cookie : cookies) {
						// cookiesValues = cookie.getName() + "=" +
						// cookie.getValue()+";";
						System.out.println(cookie.getName() + "=" + cookie.getValue() + ";");
						map.put(cookie.getName(), cookie.getValue());
					}
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				// 关闭流并释放资源
				client.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}

	/**
	 * 单品测试 *
	 */
	//@Test(dependsOnMethods="login")
	public void pickUpGoodsTest01() {
		String JSESSIONID = (String) map.get("JSESSIONID");
		String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
				+ "JSESSIONID=" + JSESSIONID;
		System.out.println("CookiesValues=" + cookiesValues);
		OkHttpClient client = new OkHttpClient();
		Request request = new Request.Builder().url("https://test.mjitech.com/web/pick_up_goods/36/75636").get()
				// .addHeader("Cookie",
				// "mjitech_username='gangwang@mjitech.com';
				// _ga=GA1.2.1640278628.1537349020;
				// JSESSIONID=E0430372DC47BC880A93537AF0387924")
				.addHeader("Cookie", cookiesValues).addHeader("cache-control", "no-cache")
				.addHeader("Postman-Token", "ee590a55-6c93-413b-b60b-21b4a88f38fe").build();
		try {
			Response response = client.newCall(request).execute();
			System.out.println("抓取结果：" + response);					
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		try {
			// 休眠30秒
			Thread.sleep(30000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
		
		
		//出仓门
		String url = "https://test.mjitech.com/web/open_goods_door?storeId=36" ;
		System.out.println("CookiesValues=" + cookiesValues);
		//String body = "{\"storeId\":\"22\"}";		
		try {
			json = service.httpPostOpenGoodsDoorReturnJson(url, cookiesValues);
			System.out.println("开舱门-"+json);
		} catch (ClientProtocolException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}
	
	
	
	
	

	/**
	 * 多品测试
	 */
	// @Test
	public void pickUpGoodsTest03() {
		String JSESSIONID = (String) map.get("JSESSIONID");
		String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
				+ "JSESSIONID=" + JSESSIONID;
		System.out.println("CookiesValues=" + cookiesValues);
		OkHttpClient client = new OkHttpClient();
		List sku_id_list = getSkuList(34);
		for (int i = 0; i < sku_id_list.size(); i++) {
			int sku_id = (Integer) sku_id_list.get(i);
			Request request = new Request.Builder().url("http://test.mjitech.com/web/pick_up_goods/34/" + sku_id + "")
					.get().addHeader("Cookie", cookiesValues).addHeader("cache-control", "no-cache")
					.addHeader("Postman-Token", "ee590a55-6c93-413b-b60b-21b4a88f38fe").build();
			try {
				Response response = client.newCall(request).execute();
				System.out.println("抓取结果：" + sku_id + response);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			try {
				// 休眠50秒
				Thread.sleep(10000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	/**
	 * 多品测试-按照货道号进行测试-华贸写字楼店
	 */
//	@Test(dependsOnMethods = "login")
	public void pickUpGoodsTestXieZiLou() {
		String JSESSIONID = (String) map.get("JSESSIONID");
		String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
				+ "JSESSIONID=" + JSESSIONID;
		System.out.println("CookiesValues=" + cookiesValues);
		OkHttpClient client = new OkHttpClient();
		// List sku_id_list = getSkuList(34);86547
		// int mt_new_sku_pass[] =
		// {86509,86509,86509,86509,86509,86547,86547,86547,86547,86547};
		// int mt_new_sku_pass[] = {86575,86575,86575,86575,86575,86575};
		// 运转标准策略 10
		// {86450,86551,86555,86514,86490,86489,86569,86486,86519,86497};
		int mt_new_sku_pass[] = { 86555 };
		// 20
		// int mt_new_sku_pass[] =
		// {86593,86561,86555,86495,86490,86591,86635,86633,86528,86459};
		// 30
		// int mt_new_sku_pass[] =
		// {86537,86598,86454,86544,86614,86527,86450,86563,86464,86594};
		// 34
		// int mt_new_sku_pass[] = {86501,86517,86599,86455};
		for (int i = 0; i < mt_new_sku_pass.length; i++) {
			// int sku_id = (Integer)sku_id_list.get(i);
			Request request = new Request.Builder()
					.url("http://test.mjitech.com/web/pick_up_goods/52/" + mt_new_sku_pass[i] + "").get()
					.addHeader("Cookie", cookiesValues).addHeader("cache-control", "no-cache")
					.addHeader("Postman-Token", "ee590a55-6c93-413b-b60b-21b4a88f38fe").build();
			try {
				Response response = client.newCall(request).execute();
				System.out.println("上海测试机器-华贸写字楼店-批量抓测结果-->" + mt_new_sku_pass + response);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			try {
				// 休眠30秒
				Thread.sleep(30000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}
	
	/**
	 * 开舱门测试
	 * 
	 */
	//@Test(dependsOnMethods="login")
	public void open_goods_door() {
		String url = "https://test.mjitech.com/web/open_goods_door?storeId=61" ;
		//String url = "http://test.mjitech.com/web/open_goods_door" ;
		String JSESSIONID = (String) map.get("JSESSIONID");
		String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
				+ "JSESSIONID=" + JSESSIONID;
		System.out.println("CookiesValues=" + cookiesValues);
		//String body = "{\"storeId\":\"22\"}";		
		try {
			json = service.httpPostOpenGoodsDoorReturnJson(url, cookiesValues);
			System.out.println("出仓开舱门-"+json);
		} catch (ClientProtocolException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}
	
	
	
	
	
	/**
	 * 单品测试 多次抓测
	 */
	//@Test(dependsOnMethods="login")
	public void pickUpGoodsTest001() {				
			String JSESSIONID = (String) map.get("JSESSIONID");
			String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
					+ "JSESSIONID=" + JSESSIONID;
			System.out.println("CookiesValues=" + cookiesValues);
			OkHttpClient client = new OkHttpClient();
			for(int i=1;i<=5;i++) {
				System.out.println("清华门店开始第"+i+"次抓测");
				for(int j=0;j<6;j++) {
					Request request = new Request.Builder().url("https://preprod.mjitech.com/web/pick_up_goods/61/100227").get()
						.addHeader("Cookie", cookiesValues).addHeader("cache-control", "no-cache")
						.addHeader("Postman-Token", "ee590a55-6c93-413b-b60b-21b4a88f38fe").build();
					try {
						Response response = client.newCall(request).execute();
						System.out.println("抓取结果：" + response);					
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				
				
					try {
						// 休眠30秒
						Thread.sleep(45000);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}	
				}			
			
				//出仓，开门
				String url = "https://www.mjitech.com/web/open_goods_door?storeId=61" ;
				System.out.println("CookiesValues=" + cookiesValues);
				try {
					json = service.httpPostOpenGoodsDoorReturnJson(url, cookiesValues);
					System.out.println("出仓开门-"+json);
				} catch (ClientProtocolException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				
				try {
					// 开舱门休眠20秒
					Thread.sleep(20000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}	
			
			}
		
	}
	
	
	/**
	 * 批量测试-全门店抓取测试（每个品都抓测一遍）-清华大学门店
	 * 测试策略：每6个一出仓
	 */
//	@Test(dependsOnMethods="login")
	public void pickUpGoodsTest002() {				
			String JSESSIONID = (String) map.get("JSESSIONID");
			String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
					+ "JSESSIONID=" + JSESSIONID;
			System.out.println("CookiesValues=" + cookiesValues);
			OkHttpClient client = new OkHttpClient();
			ArrayList<String> pass_id_list = new ArrayList<String> ();
//			pass_id_list.add("102015");
//			pass_id_list.add("102016");
//			pass_id_list.add("102017");
//			pass_id_list.add("102018");
//			pass_id_list.add("102014");
//			pass_id_list.add("102035");
//			pass_id_list.add("102036");
//			pass_id_list.add("102037");
//			pass_id_list.add("102039");
//			pass_id_list.add("102040");
//			pass_id_list.add("102041");
//			pass_id_list.add("102042");
//			pass_id_list.add("102038");
//			pass_id_list.add("102067");
//			pass_id_list.add("102068");
//			pass_id_list.add("102069");
//			pass_id_list.add("102070");
//			pass_id_list.add("102071");
//			pass_id_list.add("102072");
//			pass_id_list.add("102066");
//			pass_id_list.add("101982");
//			pass_id_list.add("101984");
//			pass_id_list.add("101983");
//			pass_id_list.add("101986");
//			pass_id_list.add("101987");
//			pass_id_list.add("101985");
//			pass_id_list.add("101988");//空抓
//			pass_id_list.add("101990");
//			pass_id_list.add("101991");
//			pass_id_list.add("101992");
//			pass_id_list.add("101993");
//			pass_id_list.add("101994");
//			pass_id_list.add("101989");
//			pass_id_list.add("102006");
//			pass_id_list.add("102007");
//			pass_id_list.add("102009");
//			pass_id_list.add("102010");
//			pass_id_list.add("102011");
//			pass_id_list.add("102012");
//			pass_id_list.add("102013");
//			pass_id_list.add("102008");
//			pass_id_list.add("102043");
//			pass_id_list.add("102045");
		///////2019-07-10///////
//			pass_id_list.add("102046");			
//			pass_id_list.add("102047");
//			pass_id_list.add("102048");
//			pass_id_list.add("102049");
//			pass_id_list.add("102050");
//			pass_id_list.add("102051");
//			pass_id_list.add("102044");
//			pass_id_list.add("101925");
//			pass_id_list.add("101935");
//			pass_id_list.add("101934");
//			pass_id_list.add("101926");
//			pass_id_list.add("101927");
//			pass_id_list.add("101928");
//			pass_id_list.add("101929");
//			pass_id_list.add("101930");
//			pass_id_list.add("101931");
//			pass_id_list.add("101932");
//			pass_id_list.add("101933");
//			pass_id_list.add("101948");
//			pass_id_list.add("101950");
//			pass_id_list.add("101951");
//			pass_id_list.add("101952");
//			pass_id_list.add("101953");
//			pass_id_list.add("101949");
//			pass_id_list.add("101954");
//			pass_id_list.add("101937");
//			pass_id_list.add("101938");
//			pass_id_list.add("101939");
//			pass_id_list.add("101940");
//			pass_id_list.add("101941");
//			pass_id_list.add("101942");
//			pass_id_list.add("101936");
//			pass_id_list.add("101962");
//			pass_id_list.add("101963");
//			pass_id_list.add("101964");
//			pass_id_list.add("101965");
//			pass_id_list.add("101966");
//			pass_id_list.add("101961");
//			pass_id_list.add("101971");
//			pass_id_list.add("101972");
//			pass_id_list.add("101973");
//			pass_id_list.add("101974");
//			pass_id_list.add("101975");
//			pass_id_list.add("101914");
//			pass_id_list.add("101923");
//			pass_id_list.add("101924");
//			pass_id_list.add("101915");
//			pass_id_list.add("101916");
//			pass_id_list.add("101917");
//			pass_id_list.add("101918");
//			pass_id_list.add("101919");
//			pass_id_list.add("101920");
//			pass_id_list.add("101921");
//			pass_id_list.add("101922");
//			pass_id_list.add("101956");
//			pass_id_list.add("101957");
//			pass_id_list.add("101958");
//			pass_id_list.add("101959");
//			pass_id_list.add("101960");
//			pass_id_list.add("101955");
//			pass_id_list.add("101977");
//			pass_id_list.add("101978");
//			pass_id_list.add("101976");
//			pass_id_list.add("101980");
//	//		pass_id_list.add("101979");
//			pass_id_list.add("101981");
//			pass_id_list.add("101898");
//			pass_id_list.add("101899");
//			pass_id_list.add("101900");
//			pass_id_list.add("101901");
//			pass_id_list.add("101902");
//			pass_id_list.add("101903");
//			pass_id_list.add("101904");
//			pass_id_list.add("101905");
//			pass_id_list.add("101906");
//			pass_id_list.add("101907");
//			pass_id_list.add("101908");
//			pass_id_list.add("101909");
//			pass_id_list.add("101910");
//			pass_id_list.add("101911");
//			pass_id_list.add("101912");
//			pass_id_list.add("101913");
//			pass_id_list.add("101943");
//			pass_id_list.add("101944");
//			pass_id_list.add("101945");
//			pass_id_list.add("101947");
//			pass_id_list.add("101946");
//			pass_id_list.add("101968");
//			pass_id_list.add("101969");
//			pass_id_list.add("101970");
//			pass_id_list.add("101967");
//			pass_id_list.add("102000");
//			pass_id_list.add("102002");
//			pass_id_list.add("102003");
//			pass_id_list.add("102004");
//			pass_id_list.add("102005");
//			pass_id_list.add("102001");
//			pass_id_list.add("102023");
//			pass_id_list.add("102024");
//			pass_id_list.add("102026");
//			pass_id_list.add("102027");
//			pass_id_list.add("102028");
//			pass_id_list.add("102029");
//			pass_id_list.add("102025");
//			pass_id_list.add("102052");
//			pass_id_list.add("102054");
//			pass_id_list.add("102055");
//			pass_id_list.add("102056");
//			pass_id_list.add("102057");
//			pass_id_list.add("102058");
//			pass_id_list.add("102059");
//			pass_id_list.add("102053");
//			pass_id_list.add("102073");
//			pass_id_list.add("102075");
//			pass_id_list.add("102076");
//			pass_id_list.add("102077");
//			pass_id_list.add("102078");
//			pass_id_list.add("102074");
//			pass_id_list.add("101995");
//			pass_id_list.add("101996");
//			pass_id_list.add("101998");
//			pass_id_list.add("101999");
//			pass_id_list.add("101997");
//			pass_id_list.add("102019");
//			pass_id_list.add("102021");
//			pass_id_list.add("102022");
//			pass_id_list.add("102020");
//			pass_id_list.add("102030");
//			pass_id_list.add("102031");
//			pass_id_list.add("102032");
//			pass_id_list.add("102034");
//			pass_id_list.add("102033");
//			pass_id_list.add("102060");
//			pass_id_list.add("102062");
//			pass_id_list.add("102063");
//			pass_id_list.add("102064");
//			pass_id_list.add("102065");
//			pass_id_list.add("102061");
			
			//世通大厦
//			pass_id_list.add("80688");
//			pass_id_list.add("80591");
		
				for(int i=1;i<=pass_id_list.size();i++) {
					System.out.println("清华门店开始第"+i+"次抓测"+"--货道ID="+pass_id_list.get(i));
						Request request = new Request.Builder().url("https://test.mjitech.com/web/pick_up_goods/61/"+pass_id_list.get(i)+"").get()
							.addHeader("Cookie", cookiesValues).addHeader("cache-control", "no-cache")
							.addHeader("Postman-Token", "ee590a55-6c93-413b-b60b-21b4a88f38fe").build();
						try {
							Response response = client.newCall(request).execute();
							System.out.println("抓取结果：" + response);					
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					
					
						try {
							// 休眠30秒
							Thread.sleep(30000);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}	
						
						
						
						//判断每6个一出仓开门
						if(i%6==0) {
							//出仓，开门
							String url = "https://www.mjitech.com/web/open_goods_door?storeId=61" ;
							System.out.println("CookiesValues=" + cookiesValues);
							try {
								json = service.httpPostOpenGoodsDoorReturnJson(url, cookiesValues);
								System.out.println("出仓开门-"+json);
							} catch (ClientProtocolException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							
							try {
								// 开舱门休眠20秒
								Thread.sleep(20000);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}	
						}
						
						
				
				}

	}
	
	
	
	public static void main(String[] args) {
//		PickUpGoodsTest t =new PickUpGoodsTest();
//		t.getSkuList(50);
	}

}
